#!/usr/bin/python
# -*- coding: utf-8 -*-

#compmedsim.py: Ejecuta una comparacion de medias simple

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
from rpy import *

nombre=u"Comparación de medias entre dos variables"
tipo="Calculo"
descripcion=u"Descipcioncc"


#Inicializacion del widget
diccionarioalternativa={ "nombre":u"Hipótesis alternativa", "tipo":"SeleccionSimple", "opciones":["<",">","!="]}
significacion={"nombre":u"Significación","tipo":"EntradaTexto"}
widget={"tipo":"VariableCasoCasoVariable","opciones":[significacion,diccionarioalternativa]}

#Definicion del formato de resultados
definicionresultado = [
        {"tipo":"Tabla","nombre":"tabla1","cabecera":["Variable","Caso1","Caso2","Significacion","Valor T sginificacion","Valor T"]}
        ]

#Funcion principal
def funcionprincipal(dato,comanda,opciones):  
    diccionario={}
    condicion1=comanda[0][0]+"="+comanda[0][1]
    condicion2=comanda[0][0]+"="+comanda[0][2]
    lista1=dato.query(comanda[1],condicion1)
    lista2=dato.query(comanda[1],condicion2)
    if opciones[u"Hipótesis alternativa"]==">":
    	lateral="greater"
    elif opciones[u"Hipótesis alternativa"]=="<":
    	lateral="less"
    else:
    	lateral="two.sided"
    diccionario["iguales"]=r.t_test(lista1,lista2,var_equal=True,alt=lateral,conf_level=float(opciones[u"Significación"])/100)
    resultado=r.t_test(lista1,lista2,var_equal=True,alt=lateral,conf_level=float(opciones[u"Significación"]))
    
    diccionario["confianza"]=float(opciones[u"Significación"])/100
    diccionario["tabla1"]={}
    diccionario["tabla1"]["Variable"]=comanda[1]
    diccionario["tabla1"]["Caso1"]=comanda[0][1]
    diccionario["tabla1"]["Caso2"]=comanda[0][2]
    diccionario["tabla1"]["Significacion"]=opciones[u"Significación"]
    diccionario["tabla1"]["Valor T sginificacion"]=r.qt(float(opciones[u"Significación"]),resultado['parameter']['df'])
    diccionario["tabla1"]["Valor T"]=resultado['statistic']['t']
    return diccionario

def funcionchequeoentradausuario(opciones):  
    if not opciones.has_key(u"Significación"):
        from Driza.excepciones import OpcionesIncorrectaException
        raise OpcionesIncorrectaException
    return True

def funcionchequeocondiciones(interfazdato):
    if len(interfazdato.arrTitDiscreto())<1:
        return False
    return True
