#!/usr/bin/python
# -*- coding: utf-8 -*-

#jicuadrado.py Operación jicuadrado

#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez
#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from rpy import *

nombre="Ji Cuadrado"
tipo="Calculo"
widget={"tipo":"BondadDeAjuste","listaoperaciones":["Uniforme"]}

def funcion(dato,variable,caso,opciones):
    lista=dato.query(variable,caso)
    num=len(lista)
    numcasos=len(list(r.table(lista)))
    total=0
    #MEJOR CONDICION TODAVIA = Numero de valores/Numero de datos > 0.15
    #TODO: Cambiar por la "mejor condicion"
    if numcasos<30: 
        if opciones[u"Distribución"]=="Uniforme":
            distribucion=r.runif(numcasos,1./numcasos,1./numcasos)
        resultado=r.chisq_test(list(r.table(lista)),p=distribucion)
    else:
        rango=r.range(lista)
        limiteinferior=rango[0]-0 #TODO: Averiguar la precision del float de python
        limitesuperior=rango[1]+0
        longitudrango=limitesuperior-limiteinferior
        numdivisiones=int(0.15*num)
        divisor=longitudrango/numdivisiones
        listaobtenida=[0 for x in range(numdivisiones)]
        for reg in lista:
            posicion=int(float(reg-limiteinferior-1)/divisor)
            if posicion>=numdivisiones: posicion=numdivisiones-1
            listaobtenida[posicion]+=1
        distribucion=r.runif(numdivisiones,1./numdivisiones,1./numdivisiones)
        resultado=r.chisq_test(listaobtenida,p=distribucion)

    resultado["Percentil"]=int(opciones["Percentil"]) # Pasa al resultado sin procesar
    return resultado

def initresultado(resultado,opciones):
    resultado.addTablaSimple("resultado")
    resultado["resultado"].titulo="Ji Cuadrado"
    lista=[]
    if opciones["caso"]:
        lista.append("Caso")
    lista+=["Percentil limite",u"Significación",u"Conclusión"]
    resultado["resultado"].settitulo(lista)

def interfazresultado(resultado,listaopciones,floatrender=None):
    variable=listaopciones[0]
    lista=[]
    caso=listaopciones[1]
    if caso:
        lista.append(caso)
    diccionario=listaopciones[2]
    lista.append(str(diccionario["Percentil"]))
    lista.append(str(diccionario["p.value"]))
    if diccionario["p.value"]*100>diccionario["Percentil"]:
        lista.append("Se ajusta a la distribucion")
    else:
        lista.append("No se ajusta a la distribucion")
    resultado["resultado"].set(variable,lista)


def comprobarentrada(opciones):  
    pass
