#!/usr/bin/python
# -*- coding: utf-8 -*-

#Clases que gestionan la selección
#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *

image0_data = [
"23 20 2 1",
"# c #313031",
". c #ffffff",
".......................",
".......................",
"......##...............",
"......#.#..............",
"......#..#.............",
"......#...#............",
"......#....#...........",
"......#.....#..........",
"......#......#.........",
"......#.......#........",
"......#.......#........",
"......#......#.........",
"......#.....#..........",
"......#....#...........",
"......#...#............",
"......#..#.............",
"......#.#..............",
"......##...............",
".......................",
"......................."
]
image1_data = [
"23 20 2 1",
"# c #313031",
". c #ffffff",
".......................",
".......................",
"...............##......",
"..............#.#......",
".............#..#......",
"............#...#......",
"...........#....#......",
"..........#.....#......",
".........#......#......",
"........#.......#......",
"........#.......#......",
".........#......#......",
"..........#.....#......",
"...........#....#......",
"............#...#......",
".............#..#......",
"..............#.#......",
"...............##......",
".......................",
"......................."
]

class SelectorElementosEstudio(QWidget):
    """Clase padre de los selectores. Los selectores permiten elegir una o más variables, o una variable y un valor de esa variable, etc
    Las clases hijas deben suministrar cajadisponible,addelemento
    SelectorElementosEstudios tiene siempre una caja donde aparecen los resultados a la derecha, y provee los botones de adicion y sustracción de elementos
    """
    def __init__(self,interfazdato,cajadisponible):
        """Caja disponible son los elementos que aparecen a la izquierda en el selector"""
    	#VARIABLES PUBLICAS
    	QWidget.__init__(self,None,"selector",0)

    	image0 = QPixmap(image0_data)
    	image1 = QPixmap(image1_data)

    	WSelectorSimpleLayout = QHBoxLayout(self,11,6,"WSelectorSimpleLayout")
    	layout2 = QVBoxLayout(None,0,6,"layout2")
    	widgetStack1=QWidgetStack(self,"staaack")
    	widgetStack1.addWidget(cajadisponible)
    	widgetStack1.raiseWidget(cajadisponible)
    	widgetStack1.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,0,0,widgetStack1.sizePolicy().hasHeightForWidth()))
    	self._cajadisponible=cajadisponible
    	layout2.addWidget(widgetStack1)
    	WSelectorSimpleLayout.addLayout(layout2)
    	
    	layout1 = QVBoxLayout(None,0,6,"layout1")
    	
    	self.__pushButton1 = QPushButton(self,"pushButton1")
    	self.__pushButton1.setMaximumSize(QSize(30,30))
    	self.__pushButton1.setPixmap(image0)
    	layout1.addWidget(self.__pushButton1)
    	spacer1 = QSpacerItem(30,122,QSizePolicy.Minimum,QSizePolicy.Expanding)
    	layout1.addItem(spacer1)
    	
    	self.pushButton2 = QPushButton(self,"pushButton2")
    	self.pushButton2.setMaximumSize(QSize(30,30))
    	self.pushButton2.setPixmap(image1)
    	layout1.addWidget(self.pushButton2)
    	WSelectorSimpleLayout.addLayout(layout1)
    	
    	layout3 = QVBoxLayout(None,0,6,"layout3")
    	
    	self._textLabel2 = QLabel(self,"textLabel2")
    	layout3.addWidget(self._textLabel2)
    	
    	self._cajaseleccion = QListBox(self,"cajaseleccion")
    	self._cajaseleccion.setMinimumSize(QSize(0,60))
    	layout3.addWidget(self._cajaseleccion)
    	WSelectorSimpleLayout.addLayout(layout3)
    	self._cajaseleccion.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,0,0,self._cajaseleccion.sizePolicy().hasHeightForWidth()))
    	
    	self.setCaption("Form1")
    	self._textLabel2.setText(u"Selección")
    	
    	self.resize(QSize(294,240).expandedTo(self.minimumSizeHint()))
    	self.clearWState(Qt.WState_Polished)
    	self.__conexiones()
    	#Miembros !qt

    	self.seleccion=[]
    	self._dato=interfazdato

    def showEvent(self,ev):
    	self._actualizarcajas()
    	QWidget.showEvent(self,ev)

    def _actualizarcajas(self):
    	self._cajaseleccion.clear()
    	for valor in self.seleccion:
    		self._cajaseleccion.insertItem(str(valor))
    	self._updatecajadisponible()


    def __conexiones(self):
    	"""Establece las conexiones entre elementos"""
    	self.connect(self.__pushButton1,SIGNAL("clicked()"),self._addelemento)
    	self.connect(self.pushButton2,SIGNAL("clicked()"),self.__delelemento)


    def __delelemento(self):
    	"""Borra el elemento seleccionado en lacaja de seleccion"""
    	if self._cajaseleccion.currentText():
    		del self.seleccion[self._cajaseleccion.currentItem()]
    		self._actualizarcajas()
    

class SelectorVariable(SelectorElementosEstudio):
    """Este selector posee dos cajas y dos botones, que son pasados en la inicialización. Una de las cajas almacena todas las posibilidades,mientras que la otra almacena la seleccion"""
    def __init__(self,dato):
    	"""Clase de inicialización, almacena los componentes"""
    	SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCaja("Variables"))

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.caja.currentText():
    		self.seleccion.append(self._cajadisponible.caja.currentText().latin1())
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTit(factores=False):
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.caja.lista=lista
    	self._cajadisponible.caja.myUpdate()


class SelectorDobleVariable(SelectorElementosEstudio):
    """Este selector posee tres cajas y dos botones, que son pasados en la inicialización. Una de las cajas almacena todas las posibilidades,mientras que la otra almacena la seleccion"""

    def __init__(self,dato):
    	"""Clase de inicialización, almacena los componentes"""
    	SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCajaCaja("Variable1","Variable2"))

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.caja1.currentText() and self._cajadisponible.caja2.currentText():
    		self.seleccion.append([self._cajadisponible.caja1.currentText().latin1(),self._cajadisponible.caja2.currentText().latin1()])
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTit(factores=False):
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.caja1.lista=lista
    	self._cajadisponible.caja2.lista=lista
    	self._cajadisponible.caja1.myUpdate()
    	self._cajadisponible.caja2.myUpdate()


class SelectorVariableValor(SelectorElementosEstudio):
    """Permite escoger varias parejas variable-valor en vez de solamente variables. Utilizadas en las proporciones"""
    def __init__(self,dato):
    	"""Clase de inicialización, almacena los componentes"""
    	SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCajaCaja("Variable","Caso"))
    	self._textLabel2.setText("<b>Caso de la variable</b>")
    	self.connect(self._cajadisponible.caja1,SIGNAL("selectionChanged()"),self.__updatecaja2)

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.caja1.currentText() and self._cajadisponible.caja2.currentText():
    		self.seleccion.append([self._cajadisponible.caja1.currentText().latin1(),self._cajadisponible.caja2.currentText().latin1()])
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTit(factores=False):
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.caja1.lista=lista
    	self.__updatecaja2()
    	self._cajadisponible.caja1.myUpdate()


    def __updatecaja2(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.caja1.currentText().latin1())]
    	self._cajadisponible.caja2.lista=listacasos
    	self._cajadisponible.caja2.myUpdate()

class SelectorVariableValorValor(SelectorElementosEstudio):
    """Permite escoger varias parejas de valores para una variable dada"""
    def __init__(self,dato):
        SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionComboCombo("Variable"))
        self.connect(self._cajadisponible.caja,SIGNAL("selectionChanged()"),self.__updatecombos)

    def _addelemento(self):
        if self._cajadisponible.caja.currentText():
            lista=[self._cajadisponible.caja.currentText,self._cajadisponible.combo1.currentText,self._cajadisponible.combo2.currentText]
            self.seleccion.append(lista)
            self._actualizarcajas()

    def _updatecajadisponible(self):
        lista=[]
        for var in self._dato.arrTitDiscreto():
            if not var in self.seleccion:
                lista.append(var)
        self._cajadisponible.caja.lista=lista
        self.__updatecombos()
        self._cajadisponible.caja.myUpdate()

    def __updatecombos(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.caja.currentText().latin1())]
    	self._cajadisponible.combo1.lista=listacasos
    	self._cajadisponible.combo2.lista=listacasos
    	self._cajadisponible.combo1.myUpdate()
    	self._cajadisponible.combo2.myUpdate()


class SelectorVariableVariableValor(SelectorElementosEstudio):
    """Permite escoger varias parejas variable-valor en vez de solamente variables. Utilizadas en las proporciones"""
    def __init__(self,dato):
    	"""Clase de inicialización, almacena los componentes"""
    	SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCajaCajaCajaComboCombo("Variable","Caso","Variable4"))
    	self._textLabel2.setText("<b>Caso de la variable</b>")
    	self.connect(self._cajadisponible.zona1.caja1,SIGNAL("selectionChanged()"),self.__updatecaja2)
    	self.connect(self._cajadisponible.zona2.caja,SIGNAL("selectionChanged()"),self.__updatecombos)

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.zona1.caja1.currentText() and self._cajadisponible.zona1.caja2.currentText() and self._cajadisponible.zona2.caja.currentText():
    		array1=[self._cajadisponible.zona1.caja1.currentText().latin1(),self._cajadisponible.zona1.caja2.currentText().latin1()]
    		array2=[self._cajadisponible.zona2.caja.currentText().latin1(),self._cajadisponible.zona2.combo1.currentText().latin1(),self._cajadisponible.zona2.combo2.currentText().latin1()]
    		self.seleccion.append([array1,array2])
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTit(factores=False):
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.zona1.caja1.lista=lista
    	self._cajadisponible.zona2.caja.lista=lista
    	self.__updatecaja2()
    	self._cajadisponible.zona1.caja1.myUpdate()
    	self._cajadisponible.zona2.caja.myUpdate()


    def __updatecaja2(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.zona1.caja1.currentText().latin1())]
    	self._cajadisponible.zona1.caja2.lista=listacasos
    	self._cajadisponible.zona1.caja2.myUpdate()

    def __updatecombos(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.zona2.caja.currentText().latin1())]
    	self._cajadisponible.zona2.combo1.lista=listacasos
    	self._cajadisponible.zona2.combo2.lista=listacasos
    	self._cajadisponible.zona2.combo1.myUpdate()
    	self._cajadisponible.zona2.combo2.myUpdate()

class SelectorVariableValorValorVariable(SelectorElementosEstudio):
    """Esta clase..."""
    def __init__(self,dato):
        SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCajaComboComboCaja("Discriminador","Variable"))
    	self.connect(self._cajadisponible.zona1.caja,SIGNAL("selectionChanged()"),self.__updatecombos)

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.zona1.caja.currentText() and self._cajadisponible.zona2.caja.currentText():
    		array1=[self._cajadisponible.zona1.caja.currentText().latin1(),self._cajadisponible.zona1.combo1.currentText().latin1(),self._cajadisponible.zona1.combo2.currentText().latin1()]
    		array2=self._cajadisponible.zona2.caja.currentText().latin1()
    		self.seleccion.append([array1,array2])
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTitDiscreto():
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.zona1.caja.lista=lista
    	self._cajadisponible.zona2.caja.lista=self._dato.arrTitNumerica()
    	self._cajadisponible.zona1.caja.myUpdate()
    	self._cajadisponible.zona2.caja.myUpdate()


    def __updatecombos(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.zona1.caja.currentText().latin1())]
    	self._cajadisponible.zona1.combo1.lista=listacasos
    	self._cajadisponible.zona1.combo2.lista=listacasos
    	self._cajadisponible.zona1.combo1.myUpdate()
    	self._cajadisponible.zona1.combo2.myUpdate()


class SelectorVariableValorValorVariableVariable(SelectorElementosEstudio):
    """Esta clase..."""
    def __init__(self,dato):
        SelectorElementosEstudio.__init__(self,dato,WidgetSeleccionCajaComboComboCajaCaja("Discriminador","Variable1","Variable2"))
    	self.connect(self._cajadisponible.zona1.caja,SIGNAL("selectionChanged()"),self.__updatecombos)

    def _addelemento(self):
    	"""Añade un elemento de la seleccion de la cajadisponible"""
    	if self._cajadisponible.zona1.caja.currentText() and self._cajadisponible.zona2.caja1.currentText() and self._cajadisponible.zona2.caja2.currentText():
    		array1=[self._cajadisponible.zona1.caja.currentText().latin1(),self._cajadisponible.zona1.combo1.currentText().latin1(),self._cajadisponible.zona1.combo2.currentText().latin1()]
    		array2=[self._cajadisponible.zona2.caja1.currentText().latin1(),self._cajadisponible.zona2.caja2.currentText().latin1()]
    		self.seleccion.append([array1,array2])
    		self._actualizarcajas()

    def _updatecajadisponible(self):
    	lista=[]
    	for var in self._dato.arrTitDiscreto():
    		if not var in self.seleccion:
    			lista.append(var)
    	self._cajadisponible.zona1.caja.lista=lista
    	self._cajadisponible.zona2.caja1.lista=self._dato.arrTitNumerica()
    	self._cajadisponible.zona2.caja2.lista=self._dato.arrTitNumerica()
    	self._cajadisponible.zona1.caja.myUpdate()
    	self._cajadisponible.zona2.caja1.myUpdate()
    	self._cajadisponible.zona2.caja2.myUpdate()


    def __updatecombos(self):
    	listacasos=[str(x) for x in self._dato.getCasos(self._cajadisponible.zona1.caja.currentText().latin1())]
    	self._cajadisponible.zona1.combo1.lista=listacasos
    	self._cajadisponible.zona1.combo2.lista=listacasos
    	self._cajadisponible.zona1.combo1.myUpdate()
    	self._cajadisponible.zona1.combo2.myUpdate()

#Clases derivadas compuestas de elementos listadores

class WidgetSeleccionCaja(QVBox):
    def __init__(self,nombre,parent=None):
        from Driza.widgets.widgetsqt import WidgetListaListBox
    	QVBox.__init__(self,parent)
    	self.label=QLabel(self)
    	self.label.setText(nombre)
    	self.caja=WidgetListaListBox(self)


class WidgetSeleccionCajaCaja(QVBox):
    """Dos ListBoxLista en disposición vertical"""
    def __init__(self,nombre1,nombre2,parent=None):
        from Driza.widgets.widgetsqt import WidgetListaListBox
    	QVBox.__init__(self,parent)
    	self.label1=QLabel(self)
    	self.label1.setText(nombre1)
    	self.caja1=WidgetListaListBox(self)
    	self.label2=QLabel(self)
    	self.label2.setText(nombre2)
    	self.caja2=WidgetListaListBox(self)

class WidgetSeleccionComboCombo(QVBox):
    """Tiene un listbox y dos combobox"""
    def __init__(self,nombre,parent=None):
        from Driza.widgets.widgetsqt import WidgetListaListBox
    	QVBox.__init__(self,parent)
    	self.label1=QLabel(self)
    	self.label1.setText(nombre)
    	self.caja=WidgetListaListBox(self)
        from Driza.widgets.widgetsqt import WidgetListaComboBox
    	self.combo1=WidgetListaComboBox(self)
    	self.combo2=WidgetListaComboBox(self)

class WidgetSeleccionCajaCajaCajaComboCombo(QHBox):
    """Bastante largo el nombre"""
    def __init__(self,nombre1,nombre2,nombre3):
    	QHBox.__init__(self,None)
    	self.zona1=WidgetSeleccionCajaCaja(nombre1,nombre2,self)
    	self.zona2=WidgetSeleccionComboCombo(nombre1,self)

class WidgetSeleccionCajaComboComboCajaCaja(QHBox):
    """Bastante largo el nombre"""
    def __init__(self,nombre1,nombre2,nombre3):
    	QHBox.__init__(self,None)
    	self.zona1=WidgetSeleccionComboCombo(nombre1,self)
    	self.zona2=WidgetSeleccionCajaCaja(nombre2,nombre3,self)

class WidgetSeleccionCajaComboComboCaja(QHBox):
    """Bastante largo el nombre"""
    def __init__(self,nombre1,nombre2):
    	QHBox.__init__(self,None)
    	self.zona1=WidgetSeleccionComboCombo(nombre1,self)
    	self.zona2=WidgetSeleccionCaja(nombre2,self)

